#ifndef __DIS_AVR_H
#define __DIS_AVR_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#define P_NONE 0x0000
#define P_Rd 0x0001
#define P_Rr 0x0002
#define P_P  0x0003
#define P_K  0x0004
#define P_k	 0x0005
#define P_X  0x0006
#define P_Y  0x0007
#define	P_Z  0x0008
#define P_pX 0x0009
#define P_pY 0x000A
#define P_pZ 0x000B
#define P_Xp 0x000C
#define P_Yp 0x000D
#define P_Zp 0x000E
#define P_kk 0x000F
#define P_nX 0x0010
#define P_nY 0x0011
#define P_nZ 0x0012
#define P_Xn 0x0013
#define P_Yn 0x0014
#define P_Zn 0x0015
#define P_s  0x0016
#define P_b  0x0017
#define P_A  0x0018
#define P_Yq 0x0019
#define P_Zq 0x001A

//for opcode recognition
typedef struct avr_opcode
{
	uint16_t	mask;		//maska zna4a6ih bitov
	uint16_t	opcode;		//posle maski id biti
	const char	*name;		//imja instrukciji
	uint8_t		i_name;		//instruction type
	uint8_t		size;		//razmer v baitah
	uint8_t		param_num;	//skoko paramaov
	uint8_t		param_patt;	//with first with second param
	uint16_t	param_t1;	//4to za 1 param
	uint16_t	param_mask1;//maska 1 parama
	uint16_t	param_t2;	//4to za 2 param
	uint16_t	param_mask2; // maska 2 parama
	uint8_t		indirect_addresing; //jesli indirect addressing
} avr_opcode;

//instruction
typedef struct avr_instruction
{
	uint8_t name;
	uint8_t param_num;
	uint8_t reg1;
	uint32_t reg2;
	uint8_t param1;
	uint32_t param2;
	uint16_t addressing;
} avr_instruction;

extern avr_opcode opcode_table[];

uint16_t 	get_opcode_num( uint16_t );
void 		opcode_print( 	uint16_t, uint16_t, uint16_t );
uint16_t 	get_mask( 		uint16_t, uint16_t);

#endif
