
#include "file_bin.h"


FileBin::FileBin( const char *fname )
{
	unsigned int c_p;
	int size;
	this->file_name = fname;
	this->file = fopen( fname , "r" );
	if (this->file == NULL)
	{
		printf("Cannot open file %s\n",fname);
		abort();
	}
	c_p = ftell( this->file );
	fseek( this->file , 0L, SEEK_END );
	size = ftell( this->file );
	fseek( this->file , c_p, SEEK_SET);
	this->size = size;
	this->buffer = (char *)malloc( this->size );
	if (this->buffer == NULL)
	{
		printf("Cannot allocate memory\n");
		abort();
	}
	printf("File size: %d\n",this->size);
	fread( (char *)this->buffer, 1, this->size, this->file );
	this->cur_pos = 0;
}

FileBin::~FileBin()
{
	fclose( this->file );
	free( this->buffer );
	//delete this->buffer;
}

uint16_t FileBin::read_uint16()
{
	uint16_t u16=0x0;
	if (((unsigned int)this->size - this->cur_pos) >= 2)
	{
		//u16 = (this->buffer[this->cur_pos])+(this->buffer[this->cur_pos+1]<<8);
		memcpy( (void *)&u16, this->buffer+this->cur_pos, 2 );
		this->cur_pos += 2;
		return u16;
	} else
	if (((unsigned int)this->size - this->cur_pos) == 1)
	{
		u16 = this->buffer[this->cur_pos];
		this->cur_pos += 1;
		return u16;
	}
	return u16;
}

int FileBin::eof()
{
	if (this->cur_pos == (unsigned int)this->size)
		return TRUE;
	return FALSE;
}
